# MetaBUILD Hackaton

Welcome to the MetaBUILD hackathon. We are excited to join our friends at NEAR to empower you to push the Web3 envelope over the next two months. This is a great opportunity to discover, learn, build and grow.  We are looking forward to support you in turning your ideas into decentralized realities.

## About Fluence

Fluence provides the infrastructure and tools to enable decentralized compute for applications and backends on peer-to-peer networks. Nodes in the Fluence peer-to-peer network host addressable services comprised of WebAssembly Interface Types (IT) modules. Aqua, Fluence's purpose-built distributed systems programming language, allows developers to seamlessly program distributed networks and compose hosted services into decentralized applications. As a result, the Fluence platform allows you to quickly and effectively create and implement Web3 protocols and associated governance models.


## Challenges And Prices

Since the duration of this hackathon allows for the tackling of some serious ideas, we offer you an incremental path to challenges and prizes starting with a Beginner challenge all the way to and an Advanced challenge. We encourage you to compete for each challenge over the course of the hackathon. 


### Beginner's Challenge -- 10 x USD 150.00

Use or extend the NEAR [fluence js node]() or [marine services]() with the NEAR testnet. Examples include but are not limited to deploying an NFT contract, e.g., [Near NFT contract](https://examples.near.org/NFT), or minting a couple NFTs wih Fluence and Aqua.

### Intermediate/Advanced Challenge -- 1 x USD 1,500.00

It's time to reenergize the plain old NFT (PON) with dynamic metadata. Using Fluence and Aqua, design and implement a (sub-) protocol to create and manage dynamic NFTs deployed on the NEAR (testnet) chain using IPFS, Ceramic, Textile or a similar as your decentralized persistence layer. For example, consider a dynamic NFT representing a sports persona, stock (immutable), game or political election where event-driven data triggers updates to the NFT's metadata.

### Advanced Challenge -- 1 x USD 2,000.00

In the advanced category, we offer you multiple challenges. Pick one and make it yours.

#### NEAR Indexer

Use Fluence and Aqua to index NEAR on-chain events to a decentralized storage solution such as IPFS, Ceramic or Textile. 

* References:
  * [NEAR indexer example](https://docs.near.org/docs/tutorials/near-indexer)
  * [NEAR and Textile indexer example](https://github.com/hdriqi/near-textile-indexer-example for examples)

#### On-Chain Event Capture And Processing

Use Fluence to capture NEAR on-chain events to trigger off-chain Aqua scripts to drive Oracles, dynamic NFTs or DAO executables.

* References
* [NEAR NFT example](https://examples.near.org/NFT)
* [NEAR Sputnik DAO](https://www.sputnik.fund)
* [Sputink CLI](https://github.com/cloudmex/sputnikdao-cli)
* [Fluence Oracle example](https://github.com/fluencelabs/examples/tree/main/aqua-examples/price-oracle)


#### Managed DAO

Use Fluence and Aqua to create and manage a Sputnik V2 DAO for a dynamic NFT project, e.g., repo. We are particularly interested in seeing you tackle efficient off/on-chain separation for proposals and votes using decentralized storage solutions such as IPFS.

References
* [NEAR NFT example](https://examples.near.org/NFT)
* [NEAR Sputnik DAO](https://www.sputnik.fund)
* [Sputink CLI](https://github.com/cloudmex/sputnikdao-cli)
* [Fluence off-chain proposal validation examples](https://github.com/fluencelabs/eip712-validation-node)
 
 ## Best Use of Fluence And Aqua In Your DApp -- 1 x USD 2,000

Already got an idea or even DApp? This category challenges you to replace one or more centralized aspects of your solution or add off-chan compute or consensus capabilities with Fluence and Aqua.

### Submission Requirements

* Generously document your submission
* Provide a max three (3) minute video for Beginner challenges and a max five (5) minute video for any of the other challenges to present and demonstrate your solution
* Submit via a Github or GitLab repo with MIT or Apache 2.0 license

Judging is based on originality, functionality and completeness of the submission. In the case of multiple prizes for a given challenge, the order of submissions determines payout rank for complete and functional projects.

## Resources

Fluence has a variety of components and building blocks available to accelerate your project build.

### General

* [Fluence Documentation](https://doc.fluence.dev/docs/)
* [Aqua Book](https://doc.fluence.dev/aqua-book/)
* [Fluence Quickstart](https://github.com/fluencelabs/examples/tree/main/quickstart)
* [Fluence Examples](https://github.com/fluencelabs/examples)
* [Discord](https://fluence.chat)
* [Fluence Youtube](https://www.youtube.com/channel/UC3b5eFyKRFlEMwSJ1BTjpbw)
* [Book A Meeting With The Team](https://calendly.com/fluencehack/)


### Components and Examples

* Aqua-IPFS Integration
  * [Aqua IPFS Lib](https://doc.fluence.dev/aqua-book/libraries/aqua-ipfs)
  * [Aqua IPFS Integration Example](https://github.com/fluencelabs/examples/tree/main/aqua-examples/aqua-ipfs-integration)
* Aqua-Ceramic Integration
  * [Aqua Ceramic Integration Example](https://github.com/fluencelabs/examples/tree/main/aqua-examples/aqua-ceramic-integration)
* Issuing NTFs with Aqua and Fluence
  * [BazaarEx Example](https://github.com/tejas-kothari/BazaarEx)








